import requests
import json

class AuthorizeOpenIDRequest:
   'Common base class for all openid requests'

   def __init__(self, hostName, authCode, clientSecret):
      self.hostName = hostName
      self.authCode = authCode
      self.clientSecret = clientSecret
      
   def sendTokenRequest(self):
     r = requests.post("https://"+ self.hostName +"/moas/rest/token/accesstoken", data={'code': self.authCode, 'grant_type': 'Bearer'})
     print(r.status_code, r.reason)
     return r.text
     
   def sendUserInfoRequest(self, accessToken):
     r = requests.get("https://" +self.hostName+ "/moas/rest/protected/userinfo", headers={"Authorization": "Basic " + accessToken})
     print(r.status_code, r.reason)
     return r.text
     
